package owg.lgm;

import owg.util.math.MinMax;
import owg.util.math.Trig;

//import javax.swing.*;
//import java.awt.*;
//import java.awt.event.*;

public class ObjectTransform {
	public double x, y, angle, xScale, yScale;
	public int mWidth, mHeight, xorig, yorig;
	
	/**bounding box in local space (scaled)*/
	public double lx0, ly0, lx1, ly1;
	/**World space bounding box*/
	public double x0, y0, x1, y1;
	/**World space bounding box*/
	public double x00, y00, x10, y10, x01, y01, x11, y11;
	/**Edge slopes*/
	double s0010, s0001, s0111, s1011;
	
	/**Angle cosine and sine*/
	public double c, s;
	
	/*public static void main(String[] args)
	{
		JFrame f = new JFrame();
		Point mp = new Point();
		JPanel p = new JPanel() {
			@Override
			protected void paintComponent(Graphics g)
			{
				
				ObjectTransform o1 = new ObjectTransform(96, 164, Trig.dir(getWidth()/2.0, getHeight()/2.0, mp.x, mp.y), -20, -16, 48, 60);
				ObjectTransform o2 = new ObjectTransform(150, 164, 10, -10, -30, 60, 30);
				g.setColor(Color.LIGHT_GRAY);
				g.fillRect(0, 0, getWidth(), getHeight());
				g.setColor(Color.BLACK);
				o1.drawBox(g);
				o2.drawBox(g);
				g.setColor(Color.BLUE);
				g.drawLine((int)o1.x0, 0, (int)o1.x0, getHeight());
				g.drawLine(0, (int)o1.y0, getWidth(), (int)o1.y0);
				g.setColor(Color.RED);
				g.drawLine((int)o1.x1, 0, (int)o1.x1, getHeight());
				g.drawLine(0, (int)o1.y1, getWidth(), (int)o1.y1);
				
				System.out.println(o1.fuck(g, o2));
			}
		};
		p.addMouseMotionListener(new MouseAdapter()
		{
			@Override
			public void mouseMoved(MouseEvent e)
			{
				mp.setLocation(e.getPoint());
				p.repaint();
			}
		});
		p.setPreferredSize(new Dimension(640, 480));
		f.add(p);
		f.pack();
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.setLocationRelativeTo(null);
		f.setVisible(true);
	}
	
	protected void drawBox(Graphics g)
	{
		int x00 = (int) (x+c*lx0+s*ly0);
		int y00 = (int) (y-s*lx0+c*ly0);
		int x10 = (int) (x+c*lx1+s*ly0);
		int y10 = (int) (y-s*lx1+c*ly0);
		int x01 = (int) (x+c*lx0+s*ly1);
		int y01 = (int) (y-s*lx0+c*ly1);
		int x11 = (int) (x+c*lx1+s*ly1);
		int y11 = (int) (y-s*lx1+c*ly1);
		g.drawLine(x11, y11, x10, y10);
		g.drawLine(x10, y10, x00, y00);
		g.drawLine(x11, y11, x01, y01);
		g.drawLine(x00, y00, x01, y01);
	}
	
	protected boolean fuck(Graphics g, ObjectTransform otherTf)
	{
		ObjectTransform tf = this;
		
		//Offset in world space
		double dx = otherTf.x-tf.x;
		double dy = otherTf.y-tf.y;
		
		//Offset local to tf
		double ttx = dx*tf.c - dy*tf.s; // offset dot dir
		double tty = dx*tf.s + dy*tf.c; //-offset wedge dir
		//Other's dir local to tf
		double tpx = otherTf.c*tf.c + otherTf.s*tf.s; // other.dir dot dir
		double tpy = otherTf.c*tf.s - otherTf.s*tf.c; //-other.dir wedge dir
		
		//Other's bounding box local to tf
		double tlx00 = ttx + tpx*otherTf.lx0 - tpy * otherTf.ly0;
		double tly00 = tty + tpy*otherTf.lx0 + tpx * otherTf.ly0;

		double tlx10 = ttx + tpx*otherTf.lx1 - tpy * otherTf.ly0;
		double tly10 = tty + tpy*otherTf.lx1 + tpx * otherTf.ly0;

		double tlx01 = ttx + tpx*otherTf.lx0 - tpy * otherTf.ly1;
		double tly01 = tty + tpy*otherTf.lx0 + tpx * otherTf.ly1;

		double tlx11 = ttx + tpx*otherTf.lx1 - tpy * otherTf.ly1;
		double tly11 = tty + tpy*otherTf.lx1 + tpx * otherTf.ly1;
		
		//Try to find a separating axis along tf's edges
		if(MinMax.min(tlx00, tlx10, tlx01, tlx11) > tf.lx1)
			return false;
		if(MinMax.max(tlx00, tlx10, tlx01, tlx11) < tf.lx0)
			return false;
		if(MinMax.min(tly00, tly10, tly01, tly11) > tf.ly1)
			return false;
		if(MinMax.max(tly00, tly10, tly01, tly11) < tf.ly0)
			return false;

		//Offset local to other
		double otx = -dx*otherTf.c + dy*otherTf.s; // offset dot other.dir
		double oty = -dx*otherTf.s - dy*otherTf.c; //-offset wedge other.dir
		//Tf's dir local to other
		double opx = tpx; // dir dot otherdir
		double opy = -tpy; //-dir wedge other.dir
		
		//Tf's bounding box local to other
		double olx00 = otx + opx*tf.lx0 - opy * tf.ly0;
		double oly00 = oty + opy*tf.lx0 + opx * tf.ly0;

		double olx10 = otx + opx*tf.lx1 - opy * tf.ly0;
		double oly10 = oty + opy*tf.lx1 + opx * tf.ly0;

		double olx01 = otx + opx*tf.lx0 - opy * tf.ly1;
		double oly01 = oty + opy*tf.lx0 + opx * tf.ly1;

		double olx11 = otx + opx*tf.lx1 - opy * tf.ly1;
		double oly11 = oty + opy*tf.lx1 + opx * tf.ly1;
		
		//Try to find a separating axis along other's edges
		if(MinMax.min(olx00, olx10, olx01, olx11) > otherTf.lx1)
			return false;
		if(MinMax.max(olx00, olx10, olx01, olx11) < otherTf.lx0)
			return false;
		if(MinMax.min(oly00, oly10, oly01, oly11) > otherTf.ly1)
			return false;
		if(MinMax.max(oly00, oly10, oly01, oly11) < otherTf.ly0)
			return false;
		
		{
			g.setColor(Color.MAGENTA);
			tf.drawLocalBox(g, tlx00, tly00, tlx10, tly10, tlx01, tly01, tlx11, tly11);
			g.setColor(Color.YELLOW);
			otherTf.drawLocalBox(g, olx00, oly00, olx10, oly10, olx01, oly01, olx11, oly11);
		}
		
		return true;
	}

	protected void drawLocalBox(Graphics g, double tlx00, double tly00, double tlx10, double tly10, double tlx01, double tly01, double tlx11, double tly11)
	{
		double x00 = x + c * tlx00 + s * tly00;
		double y00 = y - s * tlx00 + c * tly00;
		double x10 = x + c * tlx10 + s * tly10;
		double y10 = y - s * tlx10 + c * tly10;
		double x01 = x + c * tlx01 + s * tly01;
		double y01 = y - s * tlx01 + c * tly01;
		double x11 = x + c * tlx11 + s * tly11;
		double y11 = y - s * tlx11 + c * tly11;
		g.drawLine((int)x00, (int)y00, (int)x10, (int)y10);
		g.drawLine((int)x01, (int)y01, (int)x11, (int)y11);
	}*/

	public ObjectTransform(double ex, double ey, double eimage_angle, int emx0, int emy0, int emx1, int emy1) {
		this.x = ex;
		this.y = ey;
		
		this.angle = eimage_angle;
		this.xScale = 1;
		this.yScale = 1;
		this.lx0 = emx0;
		this.ly0 = emy0;
		this.lx1 = emx1;
		this.ly1 = emy1;
		
		deriveBBox();
	}
	public ObjectTransform(Entity e) {
		update(e);
	}
	
	public void update(Entity e)
	{
		this.x = e.x;
		this.y = e.y;

		this.angle = e.image_angle;
		this.xScale = e.image_xscale;
		this.yScale = e.image_yscale;
		
		Sprite spr = e.getMask();
		if(spr == null)
		{
			this.lx0 = 0;
			this.ly0 = 0;
			this.lx1 = 0;
			this.ly1 = 0;
		}
		else
		{
			this.lx0 = spr.getX0()*xScale;
			this.ly0 = spr.getY0()*yScale;
			this.lx1 = spr.getX1()*xScale;
			this.ly1 = spr.getY1()*yScale;
		}
		
		deriveBBox();
	}
	
	protected void deriveBBox()

	{
		if(angle == 0)
		{
			c = 1;
			s = 0;

			x00 = x+lx0;
			y00 = y+ly0;

			x11 = x+lx1;
			y11 = y+ly1;

			x10 = x11;
			y10 = y00;

			x01 = x00;
			y01 = y11;
			
			x0 = Math.min(x00, x10);
			y0 = Math.min(y00, y01);
			x1 = Math.max(x00, x10);
			y1 = Math.max(y00, y01);
			
			s0010 = 0;
			s0001 = 0;
			s1011 = 0;
			s0111 = 0;
		}
		else
		{
			c = Trig.cos(angle);
			s = Trig.sin(angle);

			x00 = x+lx0*c + ly0*s;
			y00 = y-lx0*s + ly0*c;

			x10 = x+lx1*c + ly0*s;
			y10 = y-lx1*s + ly0*c;

			x01 = x+lx0*c + ly1*s;
			y01 = y-lx0*s + ly1*c;

			x11 = x+lx1*c + ly1*s;
			y11 = y-lx1*s + ly1*c;
			
			x0 = MinMax.min(x00, x10, x01, x11);
			y0 = MinMax.min(y00, y10, y01, y11);
			x1 = MinMax.max(x00, x10, x01, x11);
			y1 = MinMax.max(y00, y10, y01, y11);
			
			s0010 = (y10-y00);
			if(s0010 != 0)
				s0010 = (x10-x00)/s0010;
			s0001 = (y01-y00);
			if(s0001 != 0)
				s0001 = (x01-x00)/s0001;
			s1011 = (y11-y10);
			if(s1011 != 0)
				s1011 = (x11-x10)/s1011;
			s0111 = (y11-y01);
			if(s0111 != 0)
				s0111 = (x11-x01)/s0111;
		}
	}
	
	@Override
	public int hashCode() {
		return (int) (17*x+14*y+11*9*angle+7*lx0+5*ly0+3*lx1+ly1);
	}
	@Override
	public boolean equals(Object obj) {
		if(obj instanceof ObjectTransform)
		{
			ObjectTransform e = (ObjectTransform)obj;
			return e.x == x && e.y == y && e.angle == angle &&
					lx0 == e.lx0 && ly0 == e.ly0 && lx1 == e.x1 && ly1 == e.ly1;
		}
		return false;
	}
	public boolean matches(Entity e) {
		Sprite mask = e.getMask();
		return e.x == x && e.y == y && e.image_angle == angle && 
				(mask == null ? 
						(lx1 <= lx0 || ly1 <= ly0) : 
						(e.image_xscale*mask.getX0() == lx0 && e.image_xscale*mask.getX1() == lx1 && e.image_yscale*mask.getY0() == ly0 && e.image_yscale*mask.getY1() == ly1)
				);
	}
	
	@Override
	public String toString()
	{
		return x0+", "+y0+", "+x1+", "+y1;
	}
}
