package owg.lgm.ar1.stuff.animals;

import owg.lgm.*;
import owg.lgm.ar1.Animal;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.stuff.gatenot.Hitsavedud;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Follothing extends Entity
{
	public Follothing(double x, double y)
	{
		super(x, y, 1, false, false, false, "sprite237", null);
	}
	protected Follothing(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}

	double horfitte, verfitte;
	int rig;
	double ghokk;

	@Override
	public void createEvent()
	{
		Animal animal = instance(Animal.class);
		if(animal != null)
		{
			horfitte = animal.hspeed;
			verfitte = animal.vspeed;
			rig = animal.right;
			ghokk = animal.image_index;
		}
		alarm[0] = (short)(30);
		if (instance_number(Follothing.class)<2)
			visible = true;
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		switch (alarmIndex)
		{
		case 0:
			alarm[1] = (short)(2);
			visible = true;
			if (rig==1)
			{
				sprite = Sprite.get("sprite237");
				image_xscale=1;
				image_yscale=1;
			}
			else
			{
				sprite = Sprite.get("sprite238");
				image_xscale=1;
				image_yscale=1;
			}
			if (horfitte>0.5 || horfitte<-0.5 || verfitte>0.5 || verfitte<-0.5)
			{
				if (rig==1)
				{
					sprite = Sprite.get("sprite239");
					image_xscale=1;
					image_yscale=1;
				}
				else
				{
					sprite = Sprite.get("sprite240");
					image_xscale=1;
					image_yscale=1;
				}
			}
			image_single(ghokk);
			if (place_meeting(x+0, y+0, Hitsavedud.class))
			{
				Hitsavedud hitsavedud = instance(Hitsavedud.class);
				hitsavedud.visible = false;
				global.savedud = 2;
				new AR1Dialog()
				{
					boolean did = false;
					@Override
					public void dialog() throws ConverseException
					{

						show_message("This is my home. Thanks for saving me! Here, take these valuables.");
						if(!did)
						{
							sound_play("monny");
							global.score += 80;
							did = true;
						}
						show_message("80 valuables acquired.");
						instance_destroy_all(Follothing.class);
					}
				}.start();
			}
			break;
		case 1:
			destroy();
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
}
