package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL2ES1;

public enum RenderBufferFormat
{
	DEPTH16(GL2ES1.GL_DEPTH_COMPONENT16),
	RGBA4(GL2ES1.GL_RGBA4),
	RGB5_A1(GL2ES1.GL_RGB5_A1),
	RGB565(GL2ES1.GL_RGB565),
	RGB8(GL2ES1.GL_RGB8),
	RGBA8(GL2ES1.GL_RGBA8),
	STENCIL_INDEX1(GL2ES1.GL_STENCIL_INDEX1),
	STENCIL_INDEX4(GL2ES1.GL_STENCIL_INDEX4),
	STENCIL_INDEX8(GL2ES1.GL_STENCIL_INDEX8);
	
	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(RenderBufferFormat v : values()) {
			map.put(v.value, v);
		}
	}
	public static RenderBufferFormat of(int glFormat) throws IllegalArgumentException
	{
		RenderBufferFormat r = (RenderBufferFormat) map.get(glFormat);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized renderbuffer format enum: "+glFormat+" ("+Integer.toHexString(glFormat)+")");
		return r;
	}
    
    public final int value;

	RenderBufferFormat(int value)
    {
        this.value = value;
    }
}
