package owg.lgm.util;

import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public interface FILE
{
    public String getPath();
    public default String getName()
    {
        String fname = getPath();
        return fname.substring(fname.lastIndexOf('/')+1);
    }

    public default byte[] getBytes() throws IOException
    {
        try(InputStream in = read())
        {
            ByteArrayOutputStream data = new ByteArrayOutputStream(4096);
            byte[] buf = new byte[4096];
            int r;
            while((r=in.read(buf))>0)
                data.write(buf, 0, r);
            return data.toByteArray();
        }
    }

    OutputStream write() throws FileNotFoundException;
    InputStream read() throws FileNotFoundException;

    FILE getParentFile();
    void mkdirs();

    boolean isFile();
    boolean delete();

    FILE[] listFiles() throws IOException;
    FILE getChild(String page);
}